# coding: utf-8

"""
    Valuations

    In an accounting workflow, valuations are generated for various processes at the portfolio/portfolio group level. This service can be used to retrieve and filter for accounting valuations data.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_accounting.agraph.accounting.workflow.valuations.v1.ValuationsAPI.models.v1_valuation_exception import V1ValuationException

class V1ListValuationExceptionsResponse(BaseModel):
    """
    V1ListValuationExceptionsResponse
    """
    nav_log_exception_records: Optional[conlist(V1ValuationException)] = Field(None, alias="navLogExceptionRecords")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken")
    __properties = ["navLogExceptionRecords", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ListValuationExceptionsResponse:
        """Create an instance of V1ListValuationExceptionsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in nav_log_exception_records (list)
        _items = []
        if self.nav_log_exception_records:
            for _item in self.nav_log_exception_records:
                if _item:
                    _items.append(_item.to_dict())
            _dict['navLogExceptionRecords'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ListValuationExceptionsResponse:
        """Create an instance of V1ListValuationExceptionsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ListValuationExceptionsResponse.parse_obj(obj)

        _obj = V1ListValuationExceptionsResponse.parse_obj({
            "nav_log_exception_records": [V1ValuationException.from_dict(_item) for _item in obj.get("navLogExceptionRecords")] if obj.get("navLogExceptionRecords") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

